/*
 * TetrisFrame.java
 *
 * Created on 21 de diciembre de 2006, 19:44
 */

package guitetris;
import data.*;

/**
 *
 * @author  acu
 */
public class TetrisFrame extends javax.swing.JFrame {
    private Rejilla rejilla;
    private Figura figura;
    private Mueve mueve;
    
    /** Creates new form TetrisFrame */
    public TetrisFrame() {
        initComponents();
        rejilla = new Rejilla(12,22);
        mueve=new Mueve(this, 2);
        nuevaFigura();
        mueve.reanudar();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        rejillaPanel1 = new RejillaPanel(this);
        jMenuBar1 = new javax.swing.JMenuBar();
        FileMenu = new javax.swing.JMenu();
        NewItem = new javax.swing.JMenuItem();
        ExitItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        org.jdesktop.layout.GroupLayout rejillaPanel1Layout = new org.jdesktop.layout.GroupLayout(rejillaPanel1);
        rejillaPanel1.setLayout(rejillaPanel1Layout);
        rejillaPanel1Layout.setHorizontalGroup(
            rejillaPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 200, Short.MAX_VALUE)
        );
        rejillaPanel1Layout.setVerticalGroup(
            rejillaPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 279, Short.MAX_VALUE)
        );

        FileMenu.setMnemonic('F');
        FileMenu.setText("File");
        FileMenu.setToolTipText("File");
        NewItem.setMnemonic('N');
        NewItem.setText("New");
        NewItem.setToolTipText("New");
        NewItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NewItemActionPerformed(evt);
            }
        });

        FileMenu.add(NewItem);

        ExitItem.setMnemonic('X');
        ExitItem.setText("Exit");
        ExitItem.setToolTipText("Exit");
        ExitItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitItemActionPerformed(evt);
            }
        });

        FileMenu.add(ExitItem);

        jMenuBar1.add(FileMenu);

        setJMenuBar(jMenuBar1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 400, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .add(rejillaPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(200, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 400, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .add(rejillaPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 279, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(121, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ExitItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitItemActionPerformed
// TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_ExitItemActionPerformed
    
    private void NewItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NewItemActionPerformed
// TODO add your handling code here:
        inicializaJuego();
        mueve.reanudar();
    }//GEN-LAST:event_NewItemActionPerformed
    
    /**
     * Obtiene una referencia a la Rejilla del juego
     * @return una referencia a la Rejilla del juego
     */
    public Rejilla getRejilla(){
        return rejilla;
    }
    
    /**
     * Obtiene una referencia a la Figura que cae actualmente en el juego
     * @return una referencia a la Figura actual
     */
    public Figura getFigura(){
        return figura;
    }
    
    /**
     * Obtiene una referencia al panel donde se dibujan las piezas del juego
     * @return una referencia al panel del juego
     */
    public RejillaPanel getPanel(){
        return rejillaPanel1;
    }
    
    /**
     * Obtiene una nueva figura cuyo tipo es seleccionado de forma aleatoria
     */
    public void nuevaFigura(){
        figura = Figura.nuevaFigura();
    }
    
    /**
     * Deja VACIA todas las celdas de la Rejilla, la inicializa
     * de nuevo. Además genera una nueva Figura de tipo aleatorio
     */
    public void inicializaJuego(){
        rejilla.initRejilla();
        nuevaFigura();
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new TetrisFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem ExitItem;
    private javax.swing.JMenu FileMenu;
    private javax.swing.JMenuItem NewItem;
    private javax.swing.JMenuBar jMenuBar1;
    private guitetris.RejillaPanel rejillaPanel1;
    // End of variables declaration//GEN-END:variables
    
}
